DATABASE laser

FUNCTION main
LOCAL fp:=FOPEN('laser.sdf'), dbf, buff, featbuff, featbit, ikt
settrace(.t.)

dbf = ADLClass('DBF', laser)
dbf:Send('Open')
buff = space(160)

DO WHILE FREAD (fp, @buff, 160) = 160

   dbf:Send('Append', 'LASER')

   laser->catno    = substr(buff,1,10)
   laser->title    = substr(buff,11,80)
   laser->price    = val(substr(buff,91,6))
   laser->rating   = substr(buff,97,5)
   laser->xquality = val(substr(buff,102,2))
   laser->critics  = val(substr(buff,104,1))
   laser->aquired  = ctod(substr(buff,111,2)+'/'+substr(buff,109,2)+'/'+substr(buff,107,2))

   featbuff = substr(buff,113,14)
   featbit = replicate(chr(0), 2)

   ikt = 1
   DO WHILE !ikt > 15

      IF substr(featbuff, ikt, 1) = 'T'
         featbit = bit_set (featbit, ikt)
      ENDIF
      ikt = ikt + 1
   ENDDO

   laser->features  = featbit
   laser->duration  = val(substr(buff,127,3))
   laser->sides  = val(substr(buff,130,2))
   laser->year  = val(substr(buff,132,4))
   laser->studio  = substr(buff,136,20)
   laser->kids  = iif(substr(buff,156,1)='T',.T.,.F.)
   laser->ncat  = val(substr(buff,157,2))
   qout(laser->aquired)
ENDDO

FCLOSE (fp)
INKEY(0)
QUIT()

